#include <kb.h>

enum keyst {rls,prs,hold}btn[COLS][ROWS];

/*
 MODER  00->input, 01->output, 10->AF, 11->analog
 OTYPER 0->PP, 1->OD
 PUPDR  00-> nopull, 01-> pullup, 10-> pulldn
*/

//  OD ,     pull_up
void kb_init (void)
{
 //
 for(int i=0;i<sizeof(GPIO_cols)/sizeof(GDF);i++)
 {
  GPIO_cols[i].GPIOx->MODER  &= ~(3 << GPIO_cols[i].shift*2);
  GPIO_cols[i].GPIOx->MODER  |=   1 << GPIO_cols[i].shift*2; //output

  GPIO_cols[i].GPIOx->OTYPER |= 1 << GPIO_cols[i].shift;     //open drain

  GPIO_cols[i].GPIOx->PUPDR  &= ~(3 << GPIO_cols[i].shift*2);//no pull
  GPIO_cols[i].GPIOx->BSRR    =   1 << GPIO_cols[i].shift;   //pin up
 }

 //
 for(int i=0;i<sizeof(GPIO_rows)/sizeof(GDF);i++)
 {
  GPIO_rows[i].GPIOx->MODER &= ~(3 << GPIO_rows[i].shift*2); //input

  GPIO_rows[i].GPIOx->PUPDR &= ~(3 << GPIO_rows[i].shift*2);
  GPIO_rows[i].GPIOx->PUPDR |=   1 << GPIO_rows[i].shift*2;  //pull up
 }
}

//    
void kb_init_es(void)
{
 for(int i = 0; i < sizeof(GPIO_cols)/sizeof(GDF); i++)
 {
  GPIO_cols[i].GPIOx->BRR = 1 << GPIO_cols[i].shift;
 }
}

u8 scan_keys(enum keyst btn[COLS][ROWS])
{
 static u8 count[COLS][ROWS*3];
 static u32 column = 0;
 u8 ret_tmp_key_n  = 0xff;

 for(int i = 0; i < ROWS; i++)
 {
  //       
  u32 key_st = GPIO_rows[i].GPIOx->IDR & 1 << GPIO_rows[i].shift;

  //   
  if (key_st == 0)
  {
   if (count[column][i*3]>LP)
   {
    count[column][i*3]=0;

    if(btn[column][i]==rls)
    {
     btn[column][i]=prs;
     ret_tmp_key_n = column + i*COLS;
    }

    if(count[column][i*3+1]>LH)
    {
     btn[column][i]=hold;
     count[column][i*3+1]=0;
    }
    else
     count[column][i*3+1]++;
   }
   else
    count[column][i*3]++;

   count[column][i*3+2]=LR;
  }
  else
  {
   if(count[column][i*3+2])
    count[column][i*3+2]--;
   else
   {
    count[column][i*3]=count[column][i*3+1]=0;
    btn[column][i]=rls;
   }
  }
 }

 //     
 GPIO_cols[column].GPIOx->BSRR = 1 << GPIO_cols[column].shift;

 column++;
 if(column > COLS-1) column = 0;

 //     
 GPIO_cols[column].GPIOx->BRR = 1 << GPIO_cols[column].shift;

 return ret_tmp_key_n;
}
