char const* const op_strings[] =
{
 "NOP ",
 "REM ",
 "MEM ",
 "R_0 ",
 "R_1 ",
 "R_2 ",
 "R_3 ",
 "R_4 ",
 "R_5 ",
 "R_6 ",
 "R_7 ",
 "R_8 ",
 "R_9 ",
 "R10 ",
 "R11 ",
 "R12 ",
 "R13 ",
 "R14 ",
 "R15 ",
 "R16 ",
 "R17 ",
 "R18 ",
 "R19 ",
 "M_0 ",
 "M_1 ",
 "M_2 ",
 "M_3 ",
 "M_4 ",
 "M_5 ",
 "M_6 ",
 "M_7 ",
 "M_8 ",
 "M_9 ",
 "M10 ",
 "M11 ",
 "M12 ",
 "M13 ",
 "M14 ",
 "M15 ",
 "M16 ",
 "M17 ",
 "M18 ",
 "M19 ",
 "SBT ",
 "DIV ",
 "SUM ",
 "MUL ",
 "X_Y ",
 "ENT ",
 "Cx  ",
 "OR  ",
 "AND ",
 "NOT ",
 "XOR ",
 "SIN ",
 "COS ",
 "TG  ",
 "ASN ",
 "ACS ",
 "ATG ",
 "PI  ",
 "1X  ",
 "10X ",
 "EXP ",
 "x2  ",
 "X^Y ",
 "LG  ",
 "LN  ",
 "SQR ",
 "YQX ",
 "PTR ",
 "PTL ",
 "FRC ",
     "",
     "",
     "",
     "",
     "",
     "",
     "",
     "",
     "",
 "A   ",
 "B   ",
 "C   ",
 "D   ",
 "E   ",
 "F   ",
 "0   ",
 "1   ",
 "2   ",
 "3   ",
 "4   ",
 "5   ",
 "6   ",
 "7   ",
 "8   ",
 "9   ",
 ".   ",
 "-   ",
 "E   ",
     ""
};


void outstr_truncation (char in_str[], double const val, u8 precision)
{
 const u8 mss_size    = 0x20;
 const u8 base_str_ln = 0x10;

 char smss [mss_size] = {0};

 int j = base_str_ln-1;
 int sl;

 if(val < 1 && val > -1) if(precision > 0) precision --;

 //          base_str_ln 
 do
 {
  sl = snprintf(smss,sizeof(smss),"%-*.*g",j,j,val);
  j--;
 }
 while (sl > base_str_ln);

 bool exp_trg=0;
 bool comm_trg=0;

 int n_bfr = 0;
 int n_aft = 0;

 //     ,   
 for(int i = 0; i<base_str_ln; i++)
 {
  if     (smss[i]==' ' || smss[i] == 0) break;
  else if(smss[i]=='.')                 {comm_trg = 1;}
  else if(smss[i]=='e' || smss[i]=='E') {exp_trg = 1; comm_trg=1;}

  if(!comm_trg){if(smss[i] !='-') n_bfr++;}
  else if(!exp_trg) n_aft++;
 }

 //      
 if(n_aft) n_aft--;

 //      +  
 if(precision > n_aft) precision = n_aft;

 j = n_bfr + precision;

 if(j==0)j=1;
 else if(j>15)j=15;

 snprintf(in_str,17,"%-*.*g",j,j,val);
}

